'' =================================================================================================
''
''   File....... VGA Mini Setup Station
''   Purpose.... 
                
''   Author..... MacTuxLin
''               Copyright (c) 2011
''               -- see below for terms of use
''   E-mail..... MacTuxLin@gmail.com
''   Started.... 15 Feb 2011
''   Updated.... 
''
'' =================================================================================================

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal

  _ConClkFreq = ((_clkmode - xtal1) >> 6) * _xinfreq
  _Ms_001   = _ConClkFreq / 1_000
  _Us_001   = _ConClkFreq / 1_000_000



OBJ
  KB  : "Keyboard"
  Str : "ASCII0_StrEngine"
  VGA : "VGA_Text"
  

VAR
  byte xPtr


PUB Main | i, stringPointer

  '--- --- --- --- --- --- --- --- ---
  '--- --- VGA Cog --- ---
  '--- --- --- --- --- --- --- --- ---
  ifnot(VGA.Start(16))
    reboot

  '--- --- --- --- --- --- --- --- ---
  '--- --- Keyboard Cog --- ---
  '--- --- --- --- --- --- --- --- ---
  ifnot(KB.start(26, 27))   '<--Don't have another PPB with PS2 at home!!!
    reboot


  VGA.Out($00)
  VGA.Str(String($C,6))

  xPtr := 0
  repeat
    result := KB.GetKey
    if result == $C8
      result := $08
      Str.putCharacter(result)
      VGA.Out(result)
      if xPtr
        xPtr--      
        VGA.Out($A)
        VGA.Out(xPtr)
        VGA.Out($B)
        VGA.Out($0)        
        VGA.Str(String($C,8))
        repeat i from 0 to 31-xPtr
          VGA.Out($20)
        VGA.Out($A)
        VGA.Out(xPtr)
        VGA.Out($B)
        VGA.Out($0)        
    else
      if result <> $D 
        VGA.Str(String($C,6))
        VGA.Out(result)
        Str.putCharacter(result)
        xPtr++
      else  
        VGA.Str(String($C,8))
        VGA.Str(stringPointer := Str.trimString(Str.getCharacters(true)))
        'quit
        computeX(stringPointer)
        
        

PRI computeX(stringPointer)
  